//
// Digital implementation of the high-pass, low-pass and average filters
//

#include <Arduino.h>

#ifndef _DFILTER_H
#define _DFILTER_H

#define DLP_FILTER_FILTERSHIFT 8 
#define DLP_FILTER_FILTERROUNDING 128 // (1<<7)


class dhpFilter {

	public: 
		dhpFilter(long aInitValue=0);
	
		void	initialize(long aInitValue);
		long value(long aSample);

	private:
		long	iLastSample;
		long	iShiftedFilter;
};


class dlpFilter {

	public: 
		dlpFilter(long aInitValue=0);
	
		void	initialize(long aInitValue);
		long value(long aSample);

	private:
		long	iLastSample;
		long	iShiftedFilter;
};

#define	DIGITALFILTER_NUMSAMPLES	10

class avgFilter {
	public:
		avgFilter(int aSamples=DIGITALFILTER_NUMSAMPLES);
		void initialize();
		
		long	value(long aSample);
		
	private:
		long	iReadings[DIGITALFILTER_NUMSAMPLES];
		int	iIndex;
		long	iTotal;
		int	iCount;
		int	iSamples;
};

#endif

